//vBz@~ ؼvഫ--------------By Miles Wang u9111825
#include <math.h>
#include <vcl.h>
#include <complex.h>
#pragma hdrstop
#include "SEGment.h"
#define Matrix_N 8.0
#define Pi 3.141592654
using namespace std;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
double Walsh[8][8] ={{1,1,1,1,1,1,1,1},    // Walsh[8][8]
                     {1,1,1,1,-1,-1,-1,-1},
                     {1,1,-1,-1,-1,-1,1,1},
                     {1,1,-1,-1,1,1,-1,-1},
                     {1,-1,-1,1,1,-1,-1,1},
                     {1,-1,-1,1,-1,1,1,-1},
                     {1,-1,1,-1,-1,1,-1,1},
                     {1,-1,1,-1,1,-1,1,-1}};
double Hardman[8][8]={{1,1,1,1,1,1,1,1},     // Hardman[8][8]
                     {1,-1,1,-1,1,-1,1,-1},
                     {1,1,-1,-1,1,1,-1,-1},
                     {1,-1,-1,1,1,-1,-1,1},
                     {1,1,1,1,-1,-1,-1,-1},
                     {1,-1,1,-1,-1,1,-1,1},
                     {1,1,-1,-1,-1,-1,1,1},
                     {1,-1,-1,1,-1,1,1,-1}};
complex<double> Oper_Array_copm[8][8];
complex<double> Conj_Oper_Array_copm[8][8];
complex<double> Buff_Array_copm1[8][8],Buff_Array_copm2[8][8];
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{

  if(OpenPictureDialog1->Execute()==true)
  {                  //}ɨøJϧ
    openfile=OpenPictureDialog1->FileName;
    Image1->Picture->LoadFromFile(openfile);
    Memo1->Lines->Add("}ɧ");
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  operationflag=false;                  //l
  Memo1->Lines->Add("|Jɮ");
  Label1->Caption= TrackBar1->Position;
  RadioGroup1->ItemIndex=0;
  RadioGroup2->ItemIndex=0;
 }
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Form1->Close();   //
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button4Click(TObject *Sender)
{
  if( SaveDialog1->Execute()==true)        //XJϦs
  {
    savefile=SaveDialog1->FileName;
    if(SaveDialog1->Files!=NULL)
    {
      if(RadioGroup2->ItemIndex==0)
      {
        Image1->Picture->SaveToFile(savefile);
        Memo1->Lines->Add("xsJϹϦ"+savefile);
      }
      if(RadioGroup2->ItemIndex==1)
      {
        Image2->Picture->SaveToFile(savefile);
        Memo1->Lines->Add("xsXϹϦ"+savefile);
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Computer_Error()
{
   int PictureHight,PictureWidth,Countx,County;
   int colorvalue;
   double buffer_error,Sum_Error,SumI,Mse,PSNR,SqartSum,SNR;
   //~tqB
   Sum_Error=0;
   SumI=0;
   SqartSum=0;
   PictureHight=Image1->Picture->Height;
   PictureWidth=Image1->Picture->Width;
   for(Countx=0;Countx<PictureWidth;Countx++)
     for(County=0;County<PictureHight;County++)
     {
       SumI+=Picture[Countx][County];
       SqartSum+=(Result[Countx][County]*Result[Countx][County]);
       buffer_error=Picture[Countx][County]-Result[Countx][County];
       buffer_error*=buffer_error;
       Sum_Error+=buffer_error;   //~tq֥[
     }
     Mse= Sum_Error/ PictureHight*PictureWidth;
     SqartSum/=(PictureHight*PictureWidth);
     SqartSum/=65536;
     SNR=10*log10(SqartSum/Mse);
     PSNR=10*log10(65535/Mse);
     Sum_Error/=SumI;
     Memo1->Lines->Add("SUM ERROR=");
     Memo1->Lines->Add(Sum_Error);
     Memo1->Lines->Add("PSNR=");
     Memo1->Lines->Add(PSNR);
     Memo1->Lines->Add("SNR=");
     Memo1->Lines->Add(SNR);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Computer_Answer_Matrix()  //Matrixp
{
   int PictureHight,PictureWidth,CountBx,CountBy,Countx,County,Countz;
   double answer;
   complex<double>  Canswer;

   PictureHight=Image1->Picture->Height/8;
   PictureWidth=Image1->Picture->Width/8;
   // ഫ
   for(CountBx=0;CountBx<PictureWidth;CountBx++)
     for(CountBy=0;CountBy<PictureHight;CountBy++)
     {
       if(RadioGroup1->ItemIndex!=0)    //ƹB
       {
         for(Countx=0;Countx<8;Countx++)
           for(County=0;County<8;County++)
           {
             answer=0;
             for(Countz=0;Countz<8;Countz++)
               answer=answer+Oper_Array[Countx][Countz]*Picture[CountBx*8+Countz][CountBy*8+County];
             Test_Array[Countx][County]=answer;
           }

         for(Countx=0;Countx<8;Countx++)
           for(County=0;County<8;County++)
           {
             answer=0;
             for(Countz=0;Countz<8;Countz++)
               answer=answer+Test_Array[Countx][Countz]*Oper_Array[County][Countz];
             bufferarray[Countx][County]=answer;
             if(ComboBox1->ItemIndex==0) //Xഫᤧx}
             {
               if(CheckBox2->Checked==true)
               {
                 if(answer>255)answer=255;  //x}Ȥj255h255
                 if(answer<0)answer=0;      //x}Ȥjp0h0
               }
               Result[CountBx*8+Countx][CountBy*8+County]=int(answer);
             }
           }
           //OdN*N,ls
         for(Countx=0;Countx<8;Countx++)
           for(County=0;County<8;County++)
              if(( Countx >= (TrackBar1->Position))|(County >= (TrackBar1->Position)))
                 bufferarray[Countx][County]=0;

         // ഫ
         if(ComboBox1->ItemIndex==1)
         {
           for(Countx=0;Countx<8;Countx++)
             for(County=0;County<8;County++)
             {
               answer=0;
               for(Countz=0;Countz<8;Countz++)
                 answer=answer+Oper_Array[Countz][Countx]*bufferarray[Countz][County];
               Test_Array[Countx][County]=answer;
             }


           for(Countx=0;Countx<8;Countx++)
             for(County=0;County<8;County++)
             {
               answer=0;
               for(Countz=0;Countz<8;Countz++)
                 answer=answer+Test_Array[Countx][Countz]*Oper_Array[Countz][County];
               
               if(answer>255)answer=255;  //x}Ȥj255h255
               if(answer<0)answer=0;      //x}Ȥjp0h0
               Result[CountBx*8+Countx][CountBy*8+County]=answer;
            }
         }
       }
       else
       {   //Ƽƭp
         for(Countx=0;Countx<8;Countx++)
           for(County=0;County<8;County++)
           {
             Canswer=(0.0,0);
             for(Countz=0;Countz<8;Countz++)
               Canswer=Canswer+Oper_Array_copm[Countx][Countz]*Picture[CountBx*8+Countz][CountBy*8+County];
             Buff_Array_copm1[Countx][County]=Canswer;
           }


         for(Countx=0;Countx<8;Countx++)
           for(County=0;County<8;County++)
           {
             Canswer=(0.0,0);
             for(Countz=0;Countz<8;Countz++)
               Canswer=Canswer+Buff_Array_copm1[Countx][Countz]*Oper_Array_copm[County][Countz];
             Buff_Array_copm2[Countx][County]=Canswer;
             if(ComboBox1->ItemIndex==0) //Xഫᤧx}
             {
               if(answer>255) Canswer=255;  //x}Ȥj255h255
               if(answer<0) Canswer=0;      //x}Ȥjp0h0
               Result[CountBx*8+Countx][CountBy*8+County]=real(Canswer);
             }
           }
           //OdN*N,ls
          for(Countx=0;Countx<8;Countx++)
           for(County=0;County<8;County++)
             if(( Countx >= (TrackBar1->Position))|(County >= (TrackBar1->Position)))
               Buff_Array_copm2[Countx][County]=(0.0,0);

         // ഫ
         if(ComboBox1->ItemIndex==1)
         {
           for(Countx=0;Countx<8;Countx++)
             for(County=0;County<8;County++)
             {
               Canswer=(0.0,0);
               for(Countz=0;Countz<8;Countz++)
                 Canswer=Canswer+Conj_Oper_Array_copm[Countz][Countx]*Buff_Array_copm2[Countz][County];
               Buff_Array_copm1[Countx][County]=Canswer;
             }

           for(Countx=0;Countx<8;Countx++)
             for(County=0;County<8;County++)
             {
               Canswer=(0.0,0);
               for(Countz=0;Countz<8;Countz++)
                 Canswer=Canswer+Buff_Array_copm1[Countx][Countz]*Conj_Oper_Array_copm[County][Countz];
               if(real(Canswer)>255) Canswer=(255,0);
               if(real(Canswer)<0) Canswer=(0,0);
               Result[CountBx*8+Countx][CountBy*8+County]=real(Canswer);  //X

            }
          }
        }
      }
     Drawanswer(1);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Drawanswer(int flag)
{
   int PictureHight,PictureWidth,Countx,County;
   int colorvalue;
   //XPJϧøX
   PictureHight=Image1->Picture->Height;
   PictureWidth=Image1->Picture->Width;
   for(Countx=0;Countx<PictureWidth;Countx++)
     for(County=0;County<PictureHight;County++)
     {
       switch(flag)
       {
         case(0):
           colorvalue =(int)Picture[Countx][County];
           SetPixel(Image1->Canvas->Handle,Countx,County,TColor(RGB(colorvalue,colorvalue,colorvalue)));
           break;
         case(1):
           colorvalue =(int)Result[Countx][County];
           SetPixel(Image2->Canvas->Handle,Countx,County,TColor(RGB(colorvalue,colorvalue,colorvalue)));
           break;
        }
     }

     Image1->Refresh();
     Image2->Refresh();
     operationflag=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Image2->Picture->LoadFromFile(openfile);
   Computer_Operation_Matrix();  //ഫx}p
   Computer_Answer_Matrix();     // x}
   switch(RadioGroup1->ItemIndex)
   {
     case 0:
       Memo1->Lines->Add("DFTB⧹");
       break;
     case 1:
       Memo1->Lines->Add("DHTB⧹");
       break;
     case 2:
       Memo1->Lines->Add("DCTB⧹");
       break;
     case 3:
       Memo1->Lines->Add("WalshB⧹");
       break;
     case 4:
       Memo1->Lines->Add("HadamandB⧹");
       break;
   }
}

void __fastcall TForm1::Computer_Operation_Matrix()
{
  int Countx,County,Countz;
  double answer,buffer_f,alpha1,alpha2;
  double buffer_i;
  //make a decision for elments(i,j) of Matrix
  complex<double> compf(0.0,-1.00);
  complex<double> compf2(0.0,1.00);
  for(Countx=0;Countx<Matrix_N;Countx++)
    for(County=0;County<Matrix_N;County++)
    {
      switch(RadioGroup1->ItemIndex)
      {

        case 0:   //DFT
          buffer_f=2*Pi*Countx*County/(Matrix_N);
          Oper_Array_copm[Countx][County]=exp(complex<double>(compf*buffer_f))/(complex<double>(sqrt(Matrix_N)));
          Conj_Oper_Array_copm [Countx][County]=exp(complex<double>(compf2*buffer_f))/(complex<double>(sqrt(Matrix_N)));
          answer=0;
          break;
        case 1:   //DHT
          buffer_f=double((2*Pi*(double)Countx*(double)County)/((double)Matrix_N));
          answer=(cos(buffer_f)+sin(buffer_f))/sqrt((double)Matrix_N);
          break;
        case 2:   //DCT  Type2
          if(Countx==0)
            alpha1= 1.0/sqrt(2.0);
          else
            alpha1=1.0;
          answer=double(Pi*(County+0.5)*Countx/(Matrix_N));
          buffer_f=cos(answer);
          buffer_i=sqrt(2.0/(Matrix_N));
          answer=buffer_i*buffer_f*alpha1;
          break;
        case 3:   //Walsh
          answer=double(Walsh[Countx][County]/sqrt(Matrix_N));
          break;
        case 4:  //Hadamand
          answer=double(Hardman[Countx][County])/(2.0*sqrt(2.0));
          break;
       }
       Oper_Array[Countx][County]=answer;    //ഫMatrix
    }
    if(CheckBox1->Checked==true)    //p  O_x}
    {
      Memo1->Lines->Add("Proof");
      for(Countx=0;Countx<8;Countx++)
        for(County=0;County<8;County++)
       {
          answer=0;
          for(Countz=0;Countz<8;Countz++)
               answer=answer+Oper_Array[Countx][Countz]*Oper_Array[County][Countz];
            Memo1->Lines->Add(answer);
       }
    }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button5Click(TObject *Sender)
{
   int PictureHight,PictureWidth,Countx,County;
   int colorvalue;

   PictureHight=Image1->Picture->Height; //height of image
   PictureWidth=Image1->Picture->Width; //Width get information of image for Loop
   for(Countx=0;Countx<PictureWidth;Countx++)
     for(County=0;County<PictureHight;County++)
     {
       colorvalue=GetPixel(Image1->Canvas->Handle,Countx,County);
       Picture[Countx][County]=( GetRValue(colorvalue) * 77.0         //R*0.3*256
                              + GetGValue(colorvalue) * 151.0         //G*0.57*256
                              + GetBValue(colorvalue) * 28.0)/256.0;  //B*0.13*256

    }
   Memo1->Lines->Add("ǶB⧹,Jx}!!"); 
   Drawanswer(0);  //draw gray image on input image area
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
  Label1->Caption= TrackBar1->Position;    //show saved N
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
  Computer_Error();    //Error comput
}
//---------------------------------------------------------------------------



